<?php

declare(strict_types=1);

namespace App\Policies;

use App\Models\Chicken;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class ChickenPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:Chicken');
    }

    public function view(AuthUser $authUser, Chicken $chicken): bool
    {
        return $authUser->can('View:Chicken');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:Chicken');
    }

    public function update(AuthUser $authUser, Chicken $chicken): bool
    {
        return $authUser->can('Update:Chicken');
    }

    public function delete(AuthUser $authUser, Chicken $chicken): bool
    {
        return $authUser->can('Delete:Chicken');
    }

    public function restore(AuthUser $authUser, Chicken $chicken): bool
    {
        return $authUser->can('Restore:Chicken');
    }

    public function forceDelete(AuthUser $authUser, Chicken $chicken): bool
    {
        return $authUser->can('ForceDelete:Chicken');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:Chicken');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:Chicken');
    }

    public function replicate(AuthUser $authUser, Chicken $chicken): bool
    {
        return $authUser->can('Replicate:Chicken');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:Chicken');
    }
}
